%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                                PSG Type    PSG Object                  Location in Problem Statement                    Class
%matrix_scenarios_large_data           data        matrix_scenarios_large      pr_pen_g(par_poe, matrix_scenarios_large)        double
%                                                                              var_risk_g(0.alpha, matrix_scenarios_large)
%                                                                              cvar_risk_g(0.alpha, matrix_scenarios_large)
%                                                                              bpoe_g(par_bpoe, matrix_scenarios_large)
%matrix_scenarios_large_vars           vars        matrix_scenarios_large      pr_pen_g(par_poe, matrix_scenarios_large)        cell
%                                                                              var_risk_g(0.alpha, matrix_scenarios_large)
%                                                                              cvar_risk_g(0.alpha, matrix_scenarios_large)
%                                                                              bpoe_g(par_bpoe, matrix_scenarios_large)
%matrix_linearmulty_large_benchmark    bench       matrix_linearmulty_large    linearmulti(matrix_linearmulty_large)            double
%matrix_linearmulty_large_data         data        matrix_linearmulty_large    linearmulti(matrix_linearmulty_large)            double
%matrix_linearmulty_large_vars         vars        matrix_linearmulty_large    linearmulti(matrix_linearmulty_large)            cell
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = problem_POE_cycle(matrix_scenarios_large_data,matrix_scenarios_large_vars,matrix_linearmulty_large_benchmark,matrix_linearmulty_large_data,matrix_linearmulty_large_vars)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_scenarios_large',matrix_scenarios_large_data,matrix_scenarios_large_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_linearmulty_large',matrix_linearmulty_large_data,matrix_linearmulty_large_vars,matrix_linearmulty_large_benchmark,[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'for {alpha; par_poe; par_bpoe}={900; 4413.2; 4928.942},{950; 4730.8; 5324.89},{990; 5513.708; 5714.379},{995; 5611.493; 5859.674}',...
'',...
'  problem_poe_alpha, minimize',...
'  mip =1 ',...
'    pr_pen_g(par_poe, matrix_scenarios_large)',...
'  constraint: =0',...
'    linearmulti(matrix_linearmulty_large)',...
'  box: types = 1, mip=1 ',...
'  solver: cargrb, timelimit=3600',...
'',...
'  value:',...
'    var_risk_g(0.alpha, matrix_scenarios_large)  ',...
'    cvar_risk_g(0.alpha, matrix_scenarios_large)',...
'    bpoe_g(par_bpoe, matrix_scenarios_large)',...
'',...
'end for',...
' ');
%Change parameters with their values in problem statement:

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2018.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

